////////////////////////////////////////////////////////////////////////
// Customizable inventory
// Written by William Forero - v1.5 January 2012
////////////////////////////////////////////////////////////////////////
// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 2.0
// date: 011912
// prefix: custom_inventory_
//
// title: Custom_inventory
// class: Interface
// type: User
// help: Customizable inventory for RPG games.
//
// ENDHEADER
// ---------------------------------------------------------------------

var Ia[500], D[500], S[500], O[500], A[500];

STRING* o_str[500];

PANEL* pos[500];
PANEL* ship[500];
PANEL* inic[500];

BMAP* B_2;
BMAP* B_1;
BMAP* B_3;

function move_object(PANEL* A, PANEL* B, var a)//place the object in a slot
{
	A.pos_x = B.pos_x;
	A.pos_y = B.pos_y;
	S[a] = 0;
	reset(A, UNTOUCHABLE);
}
function panel_inic(var i,var I)//place all the objects in the inventory
{
	var a;
	for(a = 0;a < I;a ++)
	{
		if(D[a] == -1)
		{
			Ia[a] = i;
			break;
		}
	}
	for(a = 0;a < I;a ++)
	{
		if((Ia[a] == i) && (D[a] == -1))
		{
			D[a] = i;
			break;
		}
	}
	if(inic[a]!=NULL)
	{
		move_object(ship[i], inic[a], i);
	}
}
function Co(var O, STRING* BF, STRING* N_O)
{
	FONT* f = font_create("Arial#20b");
	B_3 = bmap_create(BF);
	o_str[O] = N_O;
	ship[O] = pan_create("bmap = B_3; flags = SHOW;", 30);
	pan_setdigits(ship[O],0,30,30,"%1.f",f,1, A[O]);
}
//////THIS FUNCTION STORES THE OBJECT VALLUES/////
function init_inventory_values()
{
	Co(0,"explo1.tga","e1");	Co(1,"explo3.tga","e3");
}
function inventory(var U, var P, var I, PANEL* bn, var R, STRING* BP, STRING* BI)
{
	var i,a,b,c, t1=400, t2=400, IR=R;
	VECTOR sd;
	
	init_inventory_values();//Create the Objects
	B_1 = bmap_create(BP);
	B_2 = bmap_create(BI);
	for (i = 0; i < P; i++)//Create the inventory
	{
		pos[i] = pan_create("bmap = B_2; flags = SHOW;", 20);
		pos[i].pos_x = t1;
		pos[i].pos_y = t2;
		t1+=60;
	}
	t1=100;	
	t2=100;
	for (i = 0; i < I; i++)	//Create the quick acsess menu
	{
		inic[i] = pan_create("bmap = B_1; flags = SHOW;", 20);
		inic[i].pos_x = t1;
		inic[i].pos_y = t2;
		if((i + 1) >= R)
		{
			t2+=100;
			t1=40;
			R = R+IR;
		}
		D[i] = -1;
		t1 += 60;
	}
	for(i = 0;i < U;i ++)	//Put the objects in the inventory
	{
		if(A[i] > 0)
		{
			set(ship[i], VISIBLE);
			panel_inic(i, I);
		}
		else
		{
			reset(ship[i], VISIBLE);
		}
	}
	while(1)
	{
		vec_set(sd.x, mouse_pos.x);
		vec_set(sd.y, mouse_pos.y);
		for(i=0;i < I;i++)
		{
			for(a=0;a < U;a++)
			{
				if(vec_dist(ship[a].pos_x, inic[i].pos_x) != 0){D[i] = -1;}//Reset D[] values
				else
				{
					D[i] = i;
					break;
				}
			}
		}
		for(i=0;i < U;i++)
		{
			if(A[i] > 0)
			{
				set(ship[i], VISIBLE);
			}
			else
			{
				reset(ship[i], VISIBLE);
			}
			if(mouse_panel == ship[i])//Display the name of the object
			{draw_text(o_str[i],mouse_pos.x +30,mouse_pos.y,vector(255,255,255));}
			if(pos[i]!=NULL)
			{
				if((vec_dist(ship[O[i]].pos_x, pos[i].pos_x) != 0)&&(vec_dist(ship[O[i]].pos_y, pos[i].pos_y) != 0))
				{O[i] = -1;}//Reset O[] value
			}
			
			if(S[i] == 1)// Which object grab?
			{
				set(ship[i], UNTOUCHABLE);//this way the object dont hinders
				ship[i].pos_x = sd.x;	ship[i].pos_y = sd.y;//Follow the mouse
				if(mouse_left)// where it is released
				{
					if(mouse_panel == bn)// outside
					{
						panel_inic(i, I);
					}
					for(a = 0;a < P;a ++)
					{
						if(mouse_panel == pos[a])//in the quick acces?
						{
							move_object(ship[i], pos[a], i);
							O[a] = i;
							break;
						}
					}
					for(a = 0;a < I;a ++)// in the inventory?
					{
						if((mouse_panel == inic[a])&&(D[a] != 1))
						{
							move_object(ship[i], inic[a], i);
							break;
						}
					}
					while(mouse_left){wait(1);}
				}
			}
		}
		if(mouse_left)
		{
			for(i = 0;i < U;i ++)
			{
				if(mouse_panel == ship[i])
				{
					S[i] = 1;
					while(mouse_left){wait(1);}
					break;
				}
			}
		}
		wait(1);
   }
}